"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _server = require("react-dom/server");

var _reactHelmet = _interopRequireDefault(require("react-helmet"));

var _jss = require("react-jss/lib/jss");

var _env = require("@sharyn/env");

var _AppWithProviders = _interopRequireDefault(require("@sharyn/shared/AppWithProviders"));

var _htmlBase = _interopRequireDefault(require("./html-base"));

var _propTypes = _interopRequireDefault(require("prop-types"));

/* eslint-disable import/no-extraneous-dependencies */
// flow-disable-next-line
// flow-disable-next-line
// flow-disable-next-line
var renderPage = function renderPage(ctx, _ref) {
  var _ref$AppWithProviders = _ref.AppWithProviders,
      AppWithProviders = _ref$AppWithProviders === void 0 ? _AppWithProviders.default : _ref$AppWithProviders,
      App = _ref.App,
      theme = _ref.theme,
      store = _ref.store,
      swPath = _ref.swPath;
  var appHtml;
  var css;
  var helmet;
  var routerContext = {};

  if (!_env.NO_SSR) {
    var sheetsRegistry = new _jss.SheetsRegistry();
    appHtml = (0, _server.renderToString)(_react.default.createElement(AppWithProviders, (0, _extends2.default)({
      url: ctx.req.url
    }, {
      App: App,
      theme: theme,
      store: store,
      routerContext: routerContext,
      sheetsRegistry: sheetsRegistry
    }, {
      isSsr: true
    })));
    css = sheetsRegistry.toString();
    helmet = _reactHelmet.default.renderStatic();
  }

  if (routerContext.action === 'REPLACE') {
    ctx.redirect(routerContext.url);
  } else {
    ctx.body = (0, _htmlBase.default)({
      appHtml: appHtml,
      css: css,
      helmet: helmet,
      swPath: swPath,
      windowVars: [['__PRELOADED_STATE__', store.getState()]]
    });
  }
};

renderPage.contextTypes = {
  AppWithProviders: _propTypes.default.func,
  App: _propTypes.default.func.isRequired,
  theme: _propTypes.default.object.isRequired,
  store: _propTypes.default.object.isRequired,
  swPath: _propTypes.default.string
};
var _default = renderPage;
exports.default = _default;